#
# spec file
#
# Copyright (c) 2021 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define name virtme
%define version 0.1.1
%define skip_python2 1

Name:           %{name}
Version:        %{version}
Release:        bp155.4.7
Summary:        Tools for virtualize the running distro or a rootfs
License:        GPL-2.0-only
Group:          Development/Tools/Other
URL:            https://git.kernel.org/cgit/utils/kernel/virtme/virtme.git
Source0:        https://git.kernel.org/pub/scm/utils/kernel/virtme/virtme.git/snapshot/%{name}-%{version}.tar.gz
Patch1:         0001-Add-save-initramfs-to-save-the-actual-generated-init.patch
Patch2:         0002-Make-save-initramfs-show-command-output-more-useful.patch
Patch3:         0003-Fix-the-error-message-for-mods-misuse.patch
Patch4:         0004-Fix-the-mods-error-even-better.patch
Patch5:         0005-mkinitramfs.py-Search-for-busybox-.-static-first.patch
Patch6:         0006-mkinitramfs-Improve-the-find_busybox-algorithm.patch
Patch7:         0007-Add-util.find_binary-to-find-binaries.patch
Patch8:         0008-modfinder-Use-find_binary_or_raise-to-find-modprobe.patch
Patch9:         0009-Enable-the-Xen-console-when-using-xen.patch
Patch10:        0001-configkernel-Add-CONFIG_INOTIFY_USER-y.patch
Patch11:        0002-Use-fsdev-multidevs-remap-on-QEMU-4.2.patch
Patch12:        0003-Add-more-typing-annotations.patch
Patch13:        0004-run.py-Extract-path-file-sanitizing-into-a-new-funct.patch
Patch14:        0005-run.py-Introduce-blk-disk-argument.patch
Patch15:        0006-Minor-sanitize_disk_args-cleanup.patch
Patch16:        aarch64-Fix-aarch64-support.patch
BuildRequires:  %{python_module setuptools}
BuildRequires:  python-rpm-macros
Requires:       busybox-static
Requires:       qemu
BuildArch:      noarch

%description
Virtme is a set of tools to run a virtualized Linux kernel that
uses the host Linux distribution or a rootfs instead of a whole
disk image.

Right now it is not really configurable enough for being useful as a
sort of sandbox.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%py3_build
# remove pycache directories
find . -name __pycache__ -type d -exec rm -fr {} +

%install
export PYTHONDONTWRITEBYTECODE=1 %py3_install

%files
%{_bindir}/virtme-configkernel
%{_bindir}/virtme-mkinitramfs
%{_bindir}/virtme-prep-kdir-mods
%{_bindir}/virtme-run
%{python_sitelib}/%{name}
%{python_sitelib}/%{name}-%{version}-py*.egg-info

%changelog
* Tue Dec 14 2021 ohering@suse.de
- Add python-rpm-macros (bsc#1180125)
* Thu Nov 12 2020 Matthias Brugger <mbrugger@suse.com>
- Update patch for aarch64 support. Does not break full emulation case.
* Fri Oct 30 2020 Matthias Brugger <mbrugger@suse.com>
- Add patch to fix aarch64 native support.
  * aarch64-Fix-aarch64-support.patch
* Wed Jul 22 2020 Marcos de Souza <mpdesouza@suse.com>
- Add patches to include some fixes and the new --blk-disk feature
  * 0001-Add-save-initramfs-to-save-the-actual-generated-init.patch
  * 0002-Make-save-initramfs-show-command-output-more-useful.patch
  * 0003-Fix-the-error-message-for-mods-misuse.patch
  * 0004-Fix-the-mods-error-even-better.patch
  * 0005-mkinitramfs.py-Search-for-busybox-.-static-first.patch
  * 0006-mkinitramfs-Improve-the-find_busybox-algorithm.patch
  * 0007-Add-util.find_binary-to-find-binaries.patch
  * 0008-modfinder-Use-find_binary_or_raise-to-find-modprobe.patch
  * 0009-Enable-the-Xen-console-when-using-xen.patch
  * 0001-configkernel-Add-CONFIG_INOTIFY_USER-y.patch
  * 0002-Use-fsdev-multidevs-remap-on-QEMU-4.2.patch
  * 0003-Add-more-typing-annotations.patch
  * 0004-run.py-Extract-path-file-sanitizing-into-a-new-funct.patch
  * 0005-run.py-Introduce-blk-disk-argument.patch
  * 0006-Minor-sanitize_disk_args-cleanup.patch
- Drop outdated patch:
  * 0001-mkinitramfs.py-Search-for-busybox-.-static-first.patch
* Thu Oct 17 2019 Marcos de Souza <mpdesouza@suse.com>
- Current Tumbleweed's busybox does not work with virtme. For now require
  busybox-static since it works;
  * 0001-mkinitramfs.py-Search-for-busybox-.-static-first.patch: Check for
    busybox-static over dynamically linked busybox
- Change the dependency to busybox-static instead of the dynamically linked on.
* Wed Oct 16 2019 Jan Engelhardt <jengelh@inai.de>
- Trim bias, conjecture and vision from descriptions.
- Use noun phrase in summary.
* Tue Oct 15 2019 Marcos de Souza <mpdesouza@suse.com>
- Remove the python3- prefix from the final package
- Added full source URL
* Tue Oct 15 2019 Marcos de Souza <mpdesouza@suse.com>
- Remove _service and add the virtme source code into the project.
* Sat Oct 12 2019 Marcos de Souza <mpdesouza@suse.com>
- Add busybox and qemu as dependencies of virtme. Now 'virtme-run
  - -installed-kernel' works out-of-the-box.
* Thu Oct 10 2019 Marcos de Souza <mpdesouza@suse.com>
- Newly released version 0.1.1
- Use an OBS service to download the tarball
- Removed all patches, since they are all included in the new version
* Mon Sep 30 2019 Marcos de Souza <mpdesouza@suse.com>
- Add a new patch to support --mods auto in openSUSE.
* Mon Sep 30 2019 Marcos de Souza <mpdesouza@suse.com>
- Update virtme version with previous patches already included in the upstream
  project
* Mon Aug 26 2019 Marcos de Souza <mpdesouza@suse.com>
- Add patches to enable experimental --kdir with modules enabled
* Thu Aug 22 2019 Marcos de Souza <mpdesouza@suse.com>
- First version of the package
